#!/bin/bash
#
############################################################################################################################
# Nom: Report_CUPS.sh                                                                                                      #
# Descripció: Report_CUPS.sh permet accedir de forma gràfica a les estadístiques generades per l'script PrintAnalyzer.     #
# Llicència: GPL v2.0                                                                                                      #
# Autor: Joan de Gracia. Servei TAC. Departament d'Ensenyament                                                             #
# Versió: 1.0                                                                                                              #
# Data: 25-03-2013                                                                                                         #
#                                                                                                                          #
# El programa PrintAnalyzer permet generar estadístiques del fitxer page_log del sistema d'impressió CUPS.                 #
# PrintAnalyzer es distribueix sota llicència GNU GPL 2.0 o superior.                                                      #
# L'autor del programa PrintAnalyzer és Thies Moeller i es pot descarregar des de la URL:                                  # 
#	http://download-mirror.savannah.gnu.org/releases//printanalyze/PrintAnalyzer                                            #
#                                                                                                                          #
############################################################################################################################

zenity --info --text="Aquest programa analitza les impressions realitzades al sistema CUPS."
LOG_CUPS=""
while [ "$LOG_CUPS" == "" ]; do
         LOG_CUPS=$(zenity --entry --text="Introdueix el nom i la ruta cap al fitxer page_log del sistema CUPS \n\r \
(Pots deixar el valor predeterminat)" --entry-text="/var/log/cups/page_log")
	if [ "$LOG_CUPS" == "" ]; then
           zenity --info --text "Informe cancel·lat" --title='Informació'
	   exit 0;
	fi
	if [ ! -f $LOG_CUPS ]; then
		LOG_CUPS=""
	fi
done
FITXER_TMP=$(mktemp)
PRINTANALYZER=/usr/share/reportcups-1.0/PrintAnalyzer
PERL=$(which perl)
RM=$(which rm)
XDG_USER_DIR=$(which xdg-user-dir)
ESCRIPTORI=$($XDG_USER_DIR DESKTOP)
CP=$(which cp)
DATA=$(which date)
HORA=$($DATA +%F_%H:%M)
PREFIX="CUPS_"
NAVEGADOR=$(which firefox)
FITXER_REPORT=$PREFIX$HORA.txt
echo -e "Informe generat en data: $HORA \r\n" >>$FITXER_TMP
$PERL $PRINTANALYZER >> $FITXER_TMP
$NAVEGADOR $FITXER_TMP
zenity --question \
       --text="Vols desar l'informe sobre el servei d'impressió CUPS?" \
       --title="Pregunta" \
       --ok-label="Sí" \
       --cancel-label="No"
      if [ "$?" == "0" ]; then
      {
	 $CP $FITXER_TMP $ESCRIPTORI/$FITXER_REPORT
         zenity --info --text "Informe desat a l'escriptori amb el nom: $FITXER_REPORT" --title='Informació'
      }
      else
      {
         zenity --info --text "Informe no desat" --title='Informació'
      }
      fi
$RM $FITXER_TMP
